﻿using UnityEngine;
using HarmonyLib;
using UltimateWater;
using System;
using System.Collections.Generic;

public class AbsoluteGyro : Mod
{
    Harmony harmony;
    public static List<WaterWavesSpectrum> editedSpectrums = new List<WaterWavesSpectrum>();
    public static List<float> editedSpectrumValues = new List<float>();
    public void Start()
    {
        harmony = new Harmony("com.aidanamite.AbsoluteGyro");
        harmony.PatchAll();
        WaterProfileBlend blender = UnityEngine.Object.FindObjectOfType<WaterProfileBlend>();
        if (blender != null)
            foreach (WaterProfile wP in blender._Profiles) {
                Traverse obj = Traverse.Create(wP.Data.Spectrum);
                editedSpectrumValues.Add(obj.Field("_Amplitude").GetValue<float>());
                obj.Field("_Amplitude").SetValue(0.1f);
                editedSpectrumValues.Add(obj.Field("_WindSpeed").GetValue<float>());
                obj.Field("_WindSpeed").SetValue(0.001f);
                editedSpectrums.Add(wP.Data.Spectrum);
            }
        Log("Mod has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll();
        int success = 0;
        int failed = 0;
        for (int i = 0;i < editedSpectrums.Count;i++)
        {
            try
            {
                Traverse obj = Traverse.Create(editedSpectrums[i]);
                obj.Field("_Amplitude").SetValue(editedSpectrumValues[i * 2]);
                obj.Field("_WindSpeed").SetValue(editedSpectrumValues[i * 2 + 1]);
                success++;
            } catch
            {
                failed++;
            }
        }
        Log("Reset wave spectrums---\n  Successful: " + success.ToString() + "\n  Failed: " + failed.ToString());
        editedSpectrums.Clear();
        editedSpectrumValues.Clear();
        Log("Mod has been unloaded!");
    }

    public static void Log(object message)
    {
        Debug.Log("[Absolute Gyro]: " + message.ToString());
    }
}

[HarmonyPatch(typeof(WaterWavesSpectrum), MethodType.Constructor, new Type[] { typeof(float), typeof(float), typeof(float), typeof(float) })]
public class Patch_WaveCalculatorCreate
{
    static void Prefix(ref WaterWavesSpectrum __instance, ref float amplitude, ref float windSpeed)
    {
        AbsoluteGyro.editedSpectrumValues.Add(amplitude);
        amplitude = 0.1f;
        AbsoluteGyro.editedSpectrumValues.Add(windSpeed);
        windSpeed = 0.001f;
        AbsoluteGyro.editedSpectrums.Add(__instance);
    }
}